require "Window"
require "Apollo"

local LUI_HideSignature = {}

function LUI_HideSignature:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self
    return o
end

function LUI_HideSignature:Init()
    Apollo.RegisterAddon(self, nil, nil, nil)
end

function LUI_HideSignature:OnLoad()
	-- Updated the addon to also reposition the xpbar/pathxpbar and to remove the glow from shop icon.
	-- Thanks to Frosthaven for the script

	self.xpbar = Apollo.GetAddon("XPBar")
	self.menu = Apollo.GetAddon("InterfaceMenuList")

	self.signature = ApolloTimer.Create(0.1, true, "OnHideSignature", self)
	self.signature:Start()

	self.glow = ApolloTimer.Create(0.1, true, "OnHideGlow", self)
	self.glow:Start()
end

function LUI_HideSignature:OnHideSignature()
	if not self.xpbar or not self.xpbar.wndMain then
		return
	end

	local xpcontainer = self.xpbar.wndMain:FindChild("BaseBarCornerForm")

	if not xpcontainer then
		self.signature:Stop()
		return
	end

	local gap = 40
	local nLeft, nTop, nRight, nBottom

	local xpbar       = xpcontainer:FindChild("XPBarContainer")
	local eldergems   = xpcontainer:FindChild("ElderGems")
	local xpbutton    = xpcontainer:FindChild("XPButton")
	local pathbar     = xpcontainer:FindChild("PathBarContainer")
	local pathbutton  = xpcontainer:FindChild("PathButton")
	local pathicon    = xpcontainer:FindChild("PathIcon")
	local indicator   = xpcontainer:FindChild("PremiumIndicator")

	if indicator then
		indicator:Show(false, true)
	end

	nLeft, nTop, nRight, nBottom = xpbar:GetAnchorOffsets()
	xpbar:SetAnchorOffsets(nLeft + gap, nTop, nRight + gap, nBottom)

	nLeft, nTop, nRight, nBottom = eldergems:GetAnchorOffsets()
	eldergems:SetAnchorOffsets(nLeft + gap, nTop, nRight + gap, nBottom)

	nLeft, nTop, nRight, nBottom = xpbutton:GetAnchorOffsets()
	xpbutton:SetAnchorOffsets(nLeft + gap, nTop, nRight + gap, nBottom)

	nLeft, nTop, nRight, nBottom = pathbar:GetAnchorOffsets()
	pathbar:SetAnchorOffsets(nLeft - gap, nTop, nRight - gap, nBottom)

	nLeft, nTop, nRight, nBottom = pathbutton:GetAnchorOffsets()
	pathbutton:SetAnchorOffsets(nLeft - gap, nTop, nRight - gap, nBottom)

	nLeft, nTop, nRight, nBottom = pathicon:GetAnchorOffsets()
	pathicon:SetAnchorOffsets(nLeft - gap - 5, nTop, nRight - gap - 5, nBottom)

	self.signature:Stop()
end

function LUI_HideSignature:OnHideGlow()
	if self.menu and self.menu.wndMain then
		local storebutton = self.menu.wndMain:FindChild("OpenMarketplaceBtn")
		if storebutton then
			storebutton:FindChild("MTXBtn_Runner"):SetSprite("ClientSprites:Clear")
		end
		self.glow:Stop()
	end
end

local LUI_HideSignatureInst = LUI_HideSignature:new()
LUI_HideSignatureInst:Init()